var express = require('express');
var io = require('socket.io');
var eventedsocket  = require('../lib/eventedsocket').eventedsocket;

var app = module.exports = express.createServer();
app.configure(function(){
  app.set('views', __dirname + '/views');
  app.set('view engine', 'jade');
  app.use(app.router);
  app.use(express.staticProvider(__dirname + '/public'));
});

// Main route 

app.get('/', function(req, res){
  res.render('index', { locals: { title : 'Eventedsocket' } });
});

// Socket.io/eventedsocket

var stream = io.listen(app);
stream.on('connection', function (client) {
  var bus = eventedsocket(client); 
  bus.emit('serversays', {
    something: 'Hello!'
  });
  bus.on('clientsays', function (data) { 
    console.log('Client says: ' + data.somethingelse);
  }); 
});

if (!module.parent) {
  app.listen(3000);
  console.log("Express server with eventedsocket/socket.io listening on port %d", app.address().port)
}
