if (typeof JSON === 'undefined') {
  throw new Error('Eventedsocket: Ouch! I need json.js! You know my main purpose is sending jsover the wire, don\'t you?');
}

(function (global) {

  var eventHandlers = {};

  function handleMsg (msg) {
    var e;
    for (e in msg) {
      if (msg.hasOwnProperty(e)) { 
	handle(e, msg[e]);
      }
    }
  }

  function handle (e, data) {
    var handlers = eventHandlers[e];
    if (handlers) {
      handlers.forEach(function (handler) {
	handler(data);
      });
    }
  }

  function on (e, f) {
    var handlers = eventHandlers[e];
    if (!handlers) {
      handlers = eventHandlers[e] = [];
    }
    handlers.push(f);
  }


  global.eventedsocket = function (socket) {

    socket.on('message', function (json) {
      try {
	handleMsg(JSON.parse(json));
      }
      catch (err) {
	throw new Error('Eventedsocket: Couldn\'t parse json message. Got ' + err + ' while parsing message ' + json);
      }
    });
    
    return {
      on: on,
      emit: function (e, data) {
	socket.send('{"' + e + '":' + JSON.stringify(data) + '}');
      }
    };
  };

})((typeof window === 'undefined') ? module.exports : window);
